/*
 *	TOPPERS/ASP Kernel
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Advanced Standard Profile Kernel
 *	
 *	Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2007-2010 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 *	$Id: target_serial.h 1824 2010-07-02 06:50:03Z mit-kimai $
 */

/*
 *	ꥢI/OǥХSIO˥ɥ饤СAPSH2Aѡ
 */

#ifndef TOPPERS_TARGET_SERIAL_H
#define TOPPERS_TARGET_SERIAL_H

#include "apsh2a.h"
#include "pdic/sh/sh_scif.h"

/*
 *	SIOγߥϥɥΥ٥ֹ
 *	աtarget_syssvc.hˤƱͤɬס
 */
#define INHNO_SIO_TX	 SCIF1_TXI_VECTOR /* ߥϥɥֹ */
#define INTNO_SIO_TX	 SCIF1_TXI_VECTOR /* ֹ */
#define INHNO_SIO_RX	 SCIF1_RXI_VECTOR /* ߥϥɥֹ */
#define INTNO_SIO_RX	 SCIF1_RXI_VECTOR /* ֹ */
#define INTPRI_SIO		 (-4)			  /* ͥ */
#define INTATR_SIO		 0U 			  /* ° */

#ifndef TOPPERS_MACRO_ONLY

/*
 *	SIOɥ饤Фν
 */
extern void sio_initialize(intptr_t exinf);

/*
 *	ꥢI/OݡȤΥץ
 */
extern SIOPCB *sio_opn_por(ID siopid, intptr_t exinf);

/*
 *	ꥢI/OݡȤΥ
 */
extern void sio_cls_por(SIOPCB *p_siopcb);

/*
 *	SIOγߥϥɥ
 */
extern void sio_tx_isr(intptr_t exinf);
extern void sio_rx_isr(intptr_t exinf);

/*
 *	ꥢI/OݡȤؤʸ
 */
#ifndef TOPPERS_HEW_SIMULATOR
extern bool_t sio_snd_chr(SIOPCB *siopcb, char_t c);

#else /* TOPPERS_HEW_SIMULATOR */

extern bool_t hew_io_sim_snd_chr(char_t c);
#define sio_snd_chr(siopcb, c) hew_io_sim_snd_chr(c)

#endif /* TOPPERS_HEW_SIMULATOR */

/*
 *	ꥢI/OݡȤʸ
 */
#ifndef TOPPERS_HEW_SIMULATOR
extern int_t sio_rcv_chr(SIOPCB *siopcb);

#else /* TOPPERS_HEW_SIMULATOR */

extern int_t hew_io_sim_rcv_chr(void);
#define sio_rcv_chr(siopcb) hew_io_sim_rcv_chr( )

#endif /* TOPPERS_HEW_SIMULATOR */

/*
 *	ꥢI/OݡȤΥХåε
 */
extern void sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *	ꥢI/OݡȤΥХåζػ
 */
extern void sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *	ꥢI/OݡȤǽХå
 */
extern void sio_irdy_snd(intptr_t exinf);

/*
 *	ꥢI/OݡȤμΥХå
 */
extern void sio_irdy_rcv(intptr_t exinf);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_TARGET_SERIAL_H */
